Loading...
Searching...
No Matches
Content-Type Header
MIME Headers

The Content-Type header indicates the media type of the message-body sent to the recipient. More...

## Data Structures

struct | msg_content_type_s
| Structure for Content-Type header. More...

## Macros

#define | MSG_CONTENT_TYPE_INIT()
| Initializer for an msg_content_type_t structure.

## Typedefs

typedef struct msg_content_type_s | msg_content_type_t
| The structure msg_content_type_t contains representation of Content-Type header.

## Enumerations

enum | { msg_content_type_hash }

## Functions

msg_content_type_t * | msg_content_type_init (msg_content_type_t x[1])
| Initialize an msg_content_type_t structure.
int | msg_is_content_type (msg_header_t const *header)
| Test if header object is an instance of msg_content_type_t.
msg_content_type_t * | msg_content_type_dup (su_home_t *home, msg_content_type_t const *header)
| Duplicate (deep copy) msg_content_type_t.
msg_content_type_t * | msg_content_type_copy (su_home_t *home, msg_content_type_t const *header)
| Copy an msg_content_type_t header structure.
msg_content_type_t * | msg_content_type_make (su_home_t *home, char const *s)
| Make a header structure msg_content_type_t.
msg_content_type_t * | msg_content_type_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Type header from formatting result.

## Variables

msg_parse_f | msg_content_type_d
| Parse a Content-Type header.
msg_print_f | msg_content_type_e
| Print a Content-Type header.
msg_hclass_t | msg_content_type_class []
| Header class for Content-Type header.

## Detailed Description

The Content-Type header indicates the media type of the message-body sent to the recipient.

Its syntax is defined in [H3.7, S20.15] as follows:

Content-Type = ( "Content-Type" | "c" ) ":" media-type
media-type = type "/" subtype *( ";" parameter )
type = token
subtype = token
Type
struct node Type

## Macro Definition Documentation

## MSG_CONTENT_TYPE_INIT

#define MSG_CONTENT_TYPE_INIT | ( |  | ) |

Initializer for an msg_content_type_t structure.

A static msg_content_type_t structure must be initialized with the MSG_CONTENT_TYPE_INIT() macro. For instance,

msg_content_type_t msg_content_type = MSG_CONTENT_TYPE_INIT;
msg_content_type_t
struct msg_content_type_s msg_content_type_t
The structure msg_content_type_t contains representation of Content-Type header.
Definition msg_mime.h:69
MSG_CONTENT_TYPE_INIT
#define MSG_CONTENT_TYPE_INIT()
Initializer for an msg_content_type_t structure.
Definition msg_mime_protos.h:102

## Typedef Documentation

## msg_content_type_t

typedef struct msg_content_type_s msg_content_type_t

The structure msg_content_type_t contains representation of Content-Type header.

The msg_content_type_t is defined as follows:

typedef struct msg_content_type_s {
msg_common_t c_common[1]; // Common fragment info
msg_unknown_t *c_next; // Dummy link to next
char const *c_type; // Pointer to type/subtype
char const *c_subtype; // Points after first slash in type
msg_param_t const *c_params; // List of parameters
} msg_content_type_t;
msg_unknown_t
struct msg_unknown_s msg_unknown_t
Type for unknown headers.
Definition msg_types.h:93
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_content_type_s
Structure for Content-Type header.
Definition msg_mime.h:132
msg_content_type_s::c_params
msg_param_t const * c_params
List of parameters.
Definition msg_mime.h:137
msg_content_type_s::c_next
msg_error_t * c_next
Dummy link to next.
Definition msg_mime.h:134
msg_content_type_s::c_common
msg_common_t c_common[1]
Common fragment info.
Definition msg_mime.h:133
msg_content_type_s::c_type
char const * c_type
Pointer to type/subtype.
Definition msg_mime.h:135
msg_content_type_s::c_subtype
char const * c_subtype
Points after first slash in type.
Definition msg_mime.h:136

The c_type is always void of whitespace, that is, there is no whitespace around the slash.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_content_type_hash | Hash of Content-Type header.

## Function Documentation

## msg_content_type_copy()

msg_content_type_t * msg_content_type_copy | ( | su_home_t * | home,
|  | msg_content_type_t const * | header )

inline

Copy an msg_content_type_t header structure.

The function msg_content_type_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  content_type = msg_content_type_copy(home, msg->msg_content_type);
  msg_content_type_copy
  msg_content_type_t * msg_content_type_copy(su_home_t *home, msg_content_type_t const *header)
  Copy an msg_content_type_t header structure.
  Definition msg_mime_protos.h:231

Returns
  The function msg_content_type_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_content_type_dup()

msg_content_type_t * msg_content_type_dup | ( | su_home_t * | home,
|  | msg_content_type_t const * | header )

inline

Duplicate (deep copy) msg_content_type_t.

The function msg_content_type_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_type = msg_content_type_dup(home, msg->msg_content_type);
  msg_content_type_dup
  msg_content_type_t * msg_content_type_dup(su_home_t *home, msg_content_type_t const *header)
  Duplicate (deep copy) msg_content_type_t.
  Definition msg_mime_protos.h:186

Returns
  The function msg_content_type_dup() returns a pointer to the newly duplicated msg_content_type_t header structure, or NULL upon an error.

## msg_content_type_format()

msg_content_type_t * msg_content_type_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Type header from formatting result.

The function msg_content_type_format() makes a new Content-Type header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_content_type_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_content_type_init()

msg_content_type_t * msg_content_type_init | ( | msg_content_type_t | x[1] | ) |

inline

Initialize an msg_content_type_t structure.

An msg_content_type_t structure can be initialized with the msg_content_type_init() function/macro. For instance,

msg_content_type_t msg_content_type;
msg_content_type_init(&msg_content_type);
msg_content_type_init
msg_content_type_t * msg_content_type_init(msg_content_type_t x[1])
Initialize an msg_content_type_t structure.
Definition msg_mime_protos.h:119

Parameters

  x | pointer to msg_content_type_t structure

## msg_content_type_make()

msg_content_type_t * msg_content_type_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_content_type_t.

The function msg_content_type_make() makes a new msg_content_type_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_content_type_make() returns a pointer to newly maked msg_content_type_t header structure, or NULL upon an error.

## msg_is_content_type()

int msg_is_content_type | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_content_type_t.

The function msg_is_content_type() returns true (nonzero) if the header class is an instance of Content-Type header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_content_type() returns true (nonzero) if the header object is an instance of header Content-Type header and false (zero) otherwise.

## Variable Documentation

## msg_content_type_class

msg_hclass_t msg_content_type_class[]

extern

Header class for Content-Type header.

The header class msg_content_type_class defines how a Content-Type header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_content_type_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.